//---------------------------------------------------------------------------------------
//  FILE:    UIScreenListener_Armory_MainMenu_LWOfficerPack
//  AUTHOR:  Amineri
//
//  PURPOSE: Implements hooks to add button to List in order to invoke OfficerUI for viewing
//--------------------------------------------------------------------------------------- 

class UIScreenListener_Armory_MainMenu_Mod extends UIScreenListener;


var UIArmory_MainMenu ParentScreen;

var UIText text;
var UIList List;
var UIBGBox	 ListBG;
var XComGameState_Unit_ModData info;
var UIListItemString_SelfContained ButtonTest;

// This event is triggered after a screen is initialized
event OnInit(UIScreen Screen)
{
	local UIPanel BG;
	local XComGameState_Unit Unit;

	ParentScreen = UIArmory_Mainmenu(Screen); 

	Unit = XComGameState_Unit(`XCOMHISTORY.GetGameStateForObjectID(ParentScreen.UnitReference.ObjectID));
	//update mousewheel controls so that mousewheel moves scrollbar when over list
    if(ParentScreen != none)
    {
			ListBG = ParentScreen.Spawn(class'UIBGBox', ParentScreen);
			ListBG.LibID = class'UIUtilities_Controls'.const.MC_X2Background;
			ListBG.InitBG('ListBG', 50, 630, 400, 400);

			//text = ParentScreen.Spawn(class'UIText', ParentScreen).InitText('',"test");

			List = ParentScreen.Spawn(class'UIList', ParentScreen);
			List.InitList('List', 50, 630, 400, 400);

			SetUpGUI(Unit);
    }

}

//This event is triggered after a screen receives focus
event OnReceiveFocus(UIScreen Screen)
{

	local XComGameState_Unit Unit;
	ParentScreen = UIArmory_Mainmenu(Screen);
	Unit = XComGameState_Unit(`XCOMHISTORY.GetGameStateForObjectID(ParentScreen.UnitReference.ObjectID));
	
	info = XComGameState_Unit_ModData(Unit.FindComponentObject(class'XComGameState_Unit_ModData'));

	SetUpGUI(Unit);
}

function SetUpGUI(XComGameState_Unit Unit)
{
	local int sexHad;
	sexHad = 0;
	List.ClearItems();
	info = XComGameState_Unit_ModData(Unit.FindComponentObject(class'XComGameState_Unit_ModData'));
	if(info!= none)
	{
		sexHad = info.Sex;
	}	

	if(Unit.GetStatus()==eStatus_Active && !info.Pregnant)
	{
		ButtonTest = UIListItemString_SelfContained(ParentScreen.Spawn(class'UIListItemString_SelfContained', List.ItemContainer).InitListItem("Breeding").SetDisabled(false, "Infiltrate alien breeding facility"));
		ButtonTest.SetButtonBGClickHander (BreederCallback);
		ButtonTest = UIListItemString_SelfContained(ParentScreen.Spawn(class'UIListItemString_SelfContained', List.ItemContainer).InitListItem("Prostitution").SetDisabled(false, "Sell her body for supplies"));
		ButtonTest.SetButtonBGClickHander (ProstitutionCallback);
	}
	else if (Unit.GetStatus()==eStatus_Active && info.Pregnant) {
		if (info.PregCur == 10) {
			ButtonTest = UIListItemString_SelfContained(ParentScreen.Spawn(class'UIListItemString_SelfContained', List.ItemContainer).InitListItem("Have baby").SetDisabled(false, "Use alien tech to accelerate pregnancy"));
			ButtonTest.SetButtonBGClickHander (HumanPregnancyCallback);
		}
		else {
			ButtonTest = UIListItemString_SelfContained(ParentScreen.Spawn(class'UIListItemString_SelfContained', List.ItemContainer).InitListItem("Study Embryo").SetDisabled(false, "Try to learn something from the alien embryo"));
			ButtonTest.SetButtonBGClickHander (AlienPregnancyCallback);
		}
	}
	UIText(List.CreateItem(class'UIText')).InitText('', "Times Sold Body: " @ string(sexHad));
	UIText(List.CreateItem(class'UIText')).InitText('', "Partner    - Fucked - Pregnancies ");
	UIText(List.CreateItem(class'UIText')).InitText('', "Advent     - "@info.SexCount[0]@"  -  "@info.PregCount[0]);
	UIText(List.CreateItem(class'UIText')).InitText('', "Sectoid    - "@info.SexCount[1]@"  -  "@info.PregCount[1]);
	UIText(List.CreateItem(class'UIText')).InitText('', "Viper      - "@info.SexCount[2]@"  -  "@info.PregCount[2]);
	UIText(List.CreateItem(class'UIText')).InitText('', "Muton      - "@info.SexCount[3]@"  -  "@info.PregCount[3]);
	UIText(List.CreateItem(class'UIText')).InitText('', "Chryssalid - "@info.SexCount[4]@"  -  "@info.PregCount[4]);
	UIText(List.CreateItem(class'UIText')).InitText('', "Faceless   - "@info.SexCount[5]@"  -  "@info.PregCount[5]);
	UIText(List.CreateItem(class'UIText')).InitText('', "Archon     - "@info.SexCount[6]@"  -  "@info.PregCount[6]);
	UIText(List.CreateItem(class'UIText')).InitText('', "Andromedon - "@info.SexCount[7]@"  -  "@info.PregCount[7]);
	UIText(List.CreateItem(class'UIText')).InitText('', "Gatekeeper - "@info.SexCount[8]@"  -  "@info.PregCount[8]);
	UIText(List.CreateItem(class'UIText')).InitText('', "Avatar     - "@info.SexCount[9]@"  -  "@info.PregCount[9]);
	UIText(List.CreateItem(class'UIText')).InitText('', "Human      - "@info.SexCount[10]@"  -  "@info.PregCount[10]);
	if (info.Pregnant) {
		UIText(List.CreateItem(class'UIText')).InitText('', "Embryo: " @string(info.PregCur));
	}
	UIText(List.CreateItem(class'UIText')).InitText('', "Sons: " @ info.sons @ " Daughters: " @info.daughters);
	
}

// This event is triggered after a screen loses focus
//event OnLoseFocus(UIScreen Screen);


// This event is triggered when a screen is removed
event OnRemoved(UIScreen Screen)
{
	//clear reference to UIScreen so it can be garbage collected
	ParentScreen = none;
}

simulated function BreederCallback(UIButton kButton)
{
	local XComGameState UpdateState;
	local XComGameState_HeadquartersXCom XComHQ;
	local XComGameState_Unit UpdatedUnit;
	local XComGameStateContext_ChangeContainer ChangeContainer;
	local XComGameState_HeadquartersProjectW WhoreProject;
	local XComGameState_Unit Unit;


		ChangeContainer = class'XComGameStateContext_ChangeContainer'.static.CreateEmptyChangeContainer("test change container");
		UpdateState = `XCOMHISTORY.CreateNewGameState(true, ChangeContainer);

		UpdatedUnit = XComGameState_Unit(UpdateState.CreateStateObject(class'XComGameState_Unit', ParentScreen.UnitReference.ObjectID));
		UpdatedUnit.SetStatus(eStatus_Training);
		UpdateState.AddStateObject(UpdatedUnit);

		XComHQ = XComGameState_HeadquartersXCom(`XCOMHISTORY.GetSingleGameStateObjectForClass(class'XComGameState_HeadquartersXCom'));
		XComHQ = XComGameState_HeadquartersXCom(UpdateState.CreateStateObject(class'XComGameState_HeadquartersXCom', XComHQ.ObjectID));
		UpdateState.AddStateObject(XComHQ);

		WhoreProject = XComGameState_HeadquartersProjectW(UpdateState.CreateStateObject(class'XComGameState_HeadquartersProjectW'));
		WhoreProject.type=1;
		WhoreProject.SetProjectFocus(UpdatedUnit.GetReference(), UpdateState);
		XComHQ.Projects.AddItem(WhoreProject.GetReference());
		UpdateState.AddStateObject(WhoreProject);


		`GAMERULES.SubmitGameState(UpdateState);

		Unit = XComGameState_Unit(`XCOMHISTORY.GetGameStateForObjectID(ParentScreen.UnitReference.ObjectID));

		ParentScreen.Header.PopulateData(Unit);
		SetUpGUI(Unit);
}
simulated function ProstitutionCallback(UIButton kButton)
{
	local XComGameState UpdateState;
	local XComGameState_HeadquartersXCom XComHQ;
	local XComGameState_Unit UpdatedUnit;
	local XComGameStateContext_ChangeContainer ChangeContainer;
	local XComGameState_HeadquartersProjectW WhoreProject;
	local XComGameState_Unit Unit;


		ChangeContainer = class'XComGameStateContext_ChangeContainer'.static.CreateEmptyChangeContainer("test change container");
		UpdateState = `XCOMHISTORY.CreateNewGameState(true, ChangeContainer);

		UpdatedUnit = XComGameState_Unit(UpdateState.CreateStateObject(class'XComGameState_Unit', ParentScreen.UnitReference.ObjectID));
		UpdatedUnit.SetStatus(eStatus_Training);
		UpdateState.AddStateObject(UpdatedUnit);

		XComHQ = XComGameState_HeadquartersXCom(`XCOMHISTORY.GetSingleGameStateObjectForClass(class'XComGameState_HeadquartersXCom'));
		XComHQ = XComGameState_HeadquartersXCom(UpdateState.CreateStateObject(class'XComGameState_HeadquartersXCom', XComHQ.ObjectID));
		UpdateState.AddStateObject(XComHQ);

		WhoreProject = XComGameState_HeadquartersProjectW(UpdateState.CreateStateObject(class'XComGameState_HeadquartersProjectW'));
		WhoreProject.type=2;
		WhoreProject.SetProjectFocus(UpdatedUnit.GetReference(), UpdateState);
		XComHQ.Projects.AddItem(WhoreProject.GetReference());
		UpdateState.AddStateObject(WhoreProject);


		`GAMERULES.SubmitGameState(UpdateState);

		Unit = XComGameState_Unit(`XCOMHISTORY.GetGameStateForObjectID(ParentScreen.UnitReference.ObjectID));

		ParentScreen.Header.PopulateData(Unit);
		SetUpGUI(Unit);
}

simulated function AlienPregnancyCallback(UIButton kButton)
{
	local XComGameState UpdateState;
	local XComGameState_HeadquartersXCom XComHQ;
	local XComGameState_Unit UpdatedUnit;
	local XComGameStateContext_ChangeContainer ChangeContainer;
	local XComGameState_HeadquartersProjectW WhoreProject;
	local XComGameState_Unit Unit;


		ChangeContainer = class'XComGameStateContext_ChangeContainer'.static.CreateEmptyChangeContainer("test change container");
		UpdateState = `XCOMHISTORY.CreateNewGameState(true, ChangeContainer);

		UpdatedUnit = XComGameState_Unit(UpdateState.CreateStateObject(class'XComGameState_Unit', ParentScreen.UnitReference.ObjectID));
		UpdatedUnit.SetStatus(eStatus_Training);
		UpdateState.AddStateObject(UpdatedUnit);

		XComHQ = XComGameState_HeadquartersXCom(`XCOMHISTORY.GetSingleGameStateObjectForClass(class'XComGameState_HeadquartersXCom'));
		XComHQ = XComGameState_HeadquartersXCom(UpdateState.CreateStateObject(class'XComGameState_HeadquartersXCom', XComHQ.ObjectID));
		UpdateState.AddStateObject(XComHQ);

		WhoreProject = XComGameState_HeadquartersProjectW(UpdateState.CreateStateObject(class'XComGameState_HeadquartersProjectW'));
		WhoreProject.type=3;
		WhoreProject.SetProjectFocus(UpdatedUnit.GetReference(), UpdateState);
		XComHQ.Projects.AddItem(WhoreProject.GetReference());
		UpdateState.AddStateObject(WhoreProject);


		`GAMERULES.SubmitGameState(UpdateState);

		Unit = XComGameState_Unit(`XCOMHISTORY.GetGameStateForObjectID(ParentScreen.UnitReference.ObjectID));

		ParentScreen.Header.PopulateData(Unit);
		SetUpGUI(Unit);
}
simulated function HumanPregnancyCallback(UIButton kButton)
{
	local XComGameState UpdateState;
	local XComGameState_HeadquartersXCom XComHQ;
	local XComGameState_Unit UpdatedUnit;
	local XComGameStateContext_ChangeContainer ChangeContainer;
	local XComGameState_HeadquartersProjectW WhoreProject;
	local XComGameState_Unit Unit;


		ChangeContainer = class'XComGameStateContext_ChangeContainer'.static.CreateEmptyChangeContainer("test change container");
		UpdateState = `XCOMHISTORY.CreateNewGameState(true, ChangeContainer);

		UpdatedUnit = XComGameState_Unit(UpdateState.CreateStateObject(class'XComGameState_Unit', ParentScreen.UnitReference.ObjectID));
		UpdatedUnit.SetStatus(eStatus_Training);
		UpdateState.AddStateObject(UpdatedUnit);

		XComHQ = XComGameState_HeadquartersXCom(`XCOMHISTORY.GetSingleGameStateObjectForClass(class'XComGameState_HeadquartersXCom'));
		XComHQ = XComGameState_HeadquartersXCom(UpdateState.CreateStateObject(class'XComGameState_HeadquartersXCom', XComHQ.ObjectID));
		UpdateState.AddStateObject(XComHQ);

		WhoreProject = XComGameState_HeadquartersProjectW(UpdateState.CreateStateObject(class'XComGameState_HeadquartersProjectW'));
		WhoreProject.type=4;
		WhoreProject.SetProjectFocus(UpdatedUnit.GetReference(), UpdateState);
		XComHQ.Projects.AddItem(WhoreProject.GetReference());
		UpdateState.AddStateObject(WhoreProject);


		`GAMERULES.SubmitGameState(UpdateState);

		Unit = XComGameState_Unit(`XCOMHISTORY.GetGameStateForObjectID(ParentScreen.UnitReference.ObjectID));

		ParentScreen.Header.PopulateData(Unit);
		SetUpGUI(Unit);
}
defaultproperties
{
	// Leaving this assigned to none will cause every screen to trigger its signals on this class
	ScreenClass = UIArmory_MainMenu;
}