// This is an Unreal Script
class X2StrategyElement_Mod extends X2StrategyElement
	dependson(X2PointOfInterestTemplate);


static function array<X2DataTemplate> CreateTemplates()
{
	local array<X2DataTemplate> Templates;

	Templates.AddItem(CreatePOIFreeCapturedSoldier());

	return Templates;
}


static function X2DataTemplate CreatePOIFreeCapturedSoldier()
{
	local X2PointOfInterestTemplate Template;

	`CREATE_X2POINTOFINTEREST_TEMPLATE(Template, 'POI_FreeCapturedSoldier');
	
	Template.IsRewardNeededFn = IsFreeCapturedSoldierRewardNeeded;
	Template.CanAppearFn = CanFreeCapturedSoldierPOIAppear;

	return Template;
}

function bool IsFreeCapturedSoldierRewardNeeded(XComGameState_PointOfInterest POIState)
{
	local XComGameState_HeadquartersAlien AlienHQ;

	local XComGameState_Unit NewUnitState;
	local XComGameStateHistory History;

	local int i;

	History = `XCOMHISTORY;

	AlienHQ = XComGameState_HeadquartersAlien(History.GetSingleGameStateObjectForClass(class'XComGameState_HeadquartersAlien'));

		for( i =0; i<AlienHQ.CapturedSoldiers.Length; i++)
		{
			NewUnitState = XComGameState_Unit(History.GetGameStateForObjectID(AlienHQ.CapturedSoldiers[i].ObjectID));
			if(NewUnitState.kAppearance.iGender == eGender_Female)
			{
				return true;
			}
		}
	return false;
}
function bool CanFreeCapturedSoldierPOIAppear(XComGameState_PointOfInterest POIState)
{
	local XComGameState_HeadquartersAlien AlienHQ;
	local XComGameStateHistory History;
	local XComGameState_Unit NewUnitState;

	local int i;
	History = `XCOMHISTORY;
	AlienHQ = XComGameState_HeadquartersAlien(History.GetSingleGameStateObjectForClass(class'XComGameState_HeadquartersAlien'));

		for( i =0; i<AlienHQ.CapturedSoldiers.Length; i++)
		{
			NewUnitState = XComGameState_Unit(History.GetGameStateForObjectID(AlienHQ.CapturedSoldiers[i].ObjectID));
			if(NewUnitState.kAppearance.iGender == eGender_Female)
			{
				return true;
			}
		}
	return false;
}
