// This is an Unreal Script
class XComGameState_HeadquartersProjectW extends XComGameState_HeadquartersProject config(ModModMod);

var config int SupplyRewardBase;
var config int IntelRewardBase;
var config int AlloyRewardBase;
var config int DustRewardBase;

var config int SupplyRewardRand;
var config int IntelRewardRand;
var config int AlloyRewardRand;
var config int DustRewardRand;

var config int BreedingTimeTaken;
var config int ProstitutionTimeTaken;
var config int AlienPregnancyTimeTaken;
var config int HumanPregnancyTimeTaken;
var config int PregnancyChance;

var config array<int> MaxPartners;

// 1: breed, 2: prostitute, 3: pregnancy
var int type;
// supplies 175 intel 100 alloy 10 elerium 5



//---------------------------------------------------------------------------------------
// Subclasses will handle most of the implementation of this function
function SetProjectFocus(StateObjectReference FocusRef, optional XComGameState NewGameState, optional StateObjectReference AuxRef)
{
	local XComGameStateHistory History;
	local XComGameState_GameTime TimeState;
	local int AverageTimeTaken;
	
	if (type == 1) AverageTimeTaken = BreedingTimeTaken;
	if (type == 2) AverageTimeTaken = ProstitutionTimeTaken;
	if (type == 3) AverageTimeTaken = AlienPregnancyTimeTaken;
	if (type == 4) AverageTimeTaken = HumanPregnancyTimeTaken;

	History = `XCOMHISTORY;

	ProjectFocus = FocusRef;
	InitialProjectPoints=AverageTimeTaken - 24 + `SYNC_RAND(48);
	ProjectPointsRemaining = InitialProjectPoints;

	TimeState = XComGameState_GameTime(History.GetSingleGameStateObjectForClass(class'XComGameState_GameTime'));
	StartDateTime = TimeState.CurrentTime;

	SetProjectedCompletionDateTime(StartDateTime);
}

// Subclasses will handle implementation, if StartState then use that instead of History
// if bAssumeActive will calculate WorkPerHour as if this item, or whatever, is current project, front of queue, and unpaused
function int CalculateWorkPerHour(optional XComGameState StartState = none, optional bool bAssumeActive = false)
{
	return 1;
}

//---------------------------------------------------------------------------------------
// Subclasses will handle implementation, call when block timer is completed
function OnBlockCompleted()
{
}

//---------------------------------------------------------------------------------------
// Subclasses will handle implementation, called when project timer is completed
function OnProjectCompleted()
{
	local UIAlert_Mod Alert;

	local XComGameState_HeadquartersXCom XComHQ, NewXComHQ;
	local XComGameState NewGameState;
	local XComGameState_Unit UnitState;
	local XComGameStateHistory History;
	local XComGameState_HeadquartersProjectW WhoreProject;
	local StateObjectReference EmptyRef;
	local XComGameState_Unit_ModData info;
	local int i;
	local int nums;
	local int droll;
	local int reward;
	local int partnertype;
	local int partnercount;
	local bool preg;
	History = `XCOMHISTORY;
	NewGameState = class'XComGameStateContext_ChangeContainer'.static.CreateChangeState("Whore_Complete");
	UnitState = XComGameState_Unit(History.GetGameStateForObjectID(ProjectFocus.ObjectID));

	Alert = `HQPRES.Spawn(class'UIAlert_Mod', `HQPRES);

	if (type == 1) {
		partnertype = `SYNC_RAND(10);
	}
	else if (type == 2) {
		partnertype = 10;
	}
	else {
		partnertype = 0;
	}
	partnercount = `SYNC_RAND(MaxPartners[partnertype]) + 1;
	if(UnitState != none)
	{
		UnitState = XComGameState_Unit(NewGameState.CreateStateObject(class'XComGameState_Unit', UnitState.ObjectID));

		UnitState.SetStatus(eStatus_Active);
		UnitState.SimGetKill(EmptyRef);
		UnitState.AddXp(5);


		info = class'XComGameState_Unit_ModData'.static.GetModDataComponent(UnitState);
		preg = false;
		nums = `SYNC_RAND(100);
		if (nums < PregnancyChance) {
			preg = true;
		}
		if(info == none)
		{
			info = XComGameState_Unit_ModData(NewGameState.CreateStateObject(class'XComGameState_Unit_ModData'));
			info.Pregnant = false;
			info.update(partnertype, partnercount, preg);
			UnitState.AddComponentObject(info);
		}
		else
		{
			if (type < 3) {
				//nums = info.Sex + 1;
				info = XComGameState_Unit_ModData(NewGameState.CreateStateObject(class'XComGameState_Unit_ModData', info.ObjectID));
				//info.Sex = nums;
				info.update(partnertype, partnercount, preg);
				Alert.Pregnant = preg;
			}
			else if (type == 3) {
				info.Pregnant = false;	
			}
			else{
				info.Pregnant = false;	
				partnercount = 1;
				if (`SYNC_RAND(2) == 0) {
					info.sons = info.sons + 1;
					partnertype = 0;
				}
				else {
					info.daughters = info.daughters + 1;
					partnertype = 1;
				}
				if (`SYNC_RAND(100) > 95) { // Twins
					if (`SYNC_RAND(2) == 0) {
						info.sons = info.sons + 1;
						partnertype = partnertype + 2;
					}
					else {
						info.daughters = info.daughters + 1;
						partnertype = partnertype + 4;
					}
				}
			}
		}
		NewGameState.AddStateObject(info);

		NewGameState.AddStateObject(UnitState);

		WhoreProject = XComGameState_HeadquartersProjectW(`XCOMHISTORY.GetGameStateForObjectID(self.ObjectID));
		
		XComHQ = XComGameState_HeadquartersXCom(History.GetSingleGameStateObjectForClass(class'XComGameState_HeadquartersXCom'));
		if (XComHQ != none)
		{
			NewXComHQ = XComGameState_HeadquartersXCom(NewGameState.CreateStateObject(class'XComGameState_HeadquartersXCom', XComHQ.ObjectID));
			NewGameState.AddStateObject(NewXComHQ);
			NewXComHQ.Projects.RemoveItem(WhoreProject.GetReference());
			NewGameState.RemoveStateObject(WhoreProject.ObjectID);

			Alert.AlertType = type;
			if (type == 1) {
				droll = `SYNC_RAND(3) + 1;
			}
			else if (type == 2) {
				droll = 0;
			}
			else if (type ==3 ){
				droll = 1;
			}
			else{
				droll = -1;
			}
			Alert.UnitName = UnitState.GetName(eNameType_FullNick);
			Alert.PartnerType = partnertype;
			Alert.PartnerCount = partnercount;
			switcH(droll)
			{
				case 0:
					Alert.Rewards = SupplyRewardBase + `SYNC_RAND(SupplyRewardRand);
					Alert.RewardName = "Supplies";
					NewXComHQ.AddResource(NewGameState, 'Supplies',Alert.Rewards);
				break;
				case 1:
					Alert.Rewards = IntelRewardBase + `SYNC_RAND(IntelRewardRand);
					Alert.RewardName = "Intel";
					NewXComHQ.AddResource(NewGameState, 'Intel',Alert.Rewards);
				break;
				case 2:
					Alert.Rewards  = AlloyRewardBase + `SYNC_RAND(AlloyRewardRand);
					Alert.RewardName = "AlienAlloy";
					NewXComHQ.AddResource(NewGameState,'AlienAlloy',Alert.Rewards);
				break;
				case 3:
					Alert.Rewards  = DustRewardBase + `SYNC_RAND(DustRewardRand);
					Alert.RewardName = "EleriumDust";
					NewXComHQ.AddResource(NewGameState, 'EleriumDust',Alert.Rewards);
				break;
			}

		
			
		}


		`XCOMGAME.GameRuleset.SubmitGameState(NewGameState);
	}
	else
	{
		History.CleanupPendingGameState(NewGameState);
	}



	`GAME.GetGeoscape().Pause();
		
		Alert.fnCallback = LowWarningCB;
		Alert.EventToTrigger = '';
		Alert.SoundToPlay = "Geoscape_ResearchComplete";
		`HQPRES.ScreenStack.Push(Alert);
}

simulated function LowWarningCB(EUIAction eAction, UIAlert AlertData, optional bool instant = false)
{
}

